//*****************************************************************************
//*****************************************************************************
//  FILENAME: OneSecTimer.h
//   Version: 2.6, Updated on 2011/12/1 at 17:23:24
//  Generated by PSoC Designer 5.2.2401
//
//  DESCRIPTION: Timer16 User Module C Language interface file
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress Semiconductor 2011. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef OneSecTimer_INCLUDE
#define OneSecTimer_INCLUDE

#include <m8c.h>

#pragma fastcall16 OneSecTimer_EnableInt
#pragma fastcall16 OneSecTimer_DisableInt
#pragma fastcall16 OneSecTimer_Start
#pragma fastcall16 OneSecTimer_Stop
#pragma fastcall16 OneSecTimer_wReadTimer                // Read  DR0
#pragma fastcall16 OneSecTimer_wReadTimerSaveCV          // Read  DR0      
#pragma fastcall16 OneSecTimer_WritePeriod               // Write DR1
#pragma fastcall16 OneSecTimer_wReadCompareValue         // Read  DR2
#pragma fastcall16 OneSecTimer_WriteCompareValue         // Write DR2

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 wOneSecTimer_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall16 wOneSecTimer_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall16 wOneSecTimer_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall16 wOneSecTimer_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall16 wOneSecTimer_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the OneSecTimer API.
//-------------------------------------------------

extern void OneSecTimer_EnableInt(void);                           // Proxy 1
extern void OneSecTimer_DisableInt(void);                          // Proxy 1
extern void OneSecTimer_Start(void);                               // Proxy 1
extern void OneSecTimer_Stop(void);                                // Proxy 1
extern WORD OneSecTimer_wReadTimer(void);                          // Proxy 1
extern WORD OneSecTimer_wReadTimerSaveCV(void);                    // Proxy 2
extern void OneSecTimer_WritePeriod(WORD wPeriod);                 // Proxy 1
extern WORD OneSecTimer_wReadCompareValue(void);                   // Proxy 1
extern void OneSecTimer_WriteCompareValue(WORD wCompareValue);     // Proxy 1

// The following functions are deprecated.
// They may be omitted in future releases
//
extern WORD wOneSecTimer_ReadCompareValue(void);       // Deprecated
extern WORD wOneSecTimer_ReadTimerSaveCV(void);        // Deprecated
extern WORD wOneSecTimer_ReadCounter(void);            // Obsolete
extern WORD wOneSecTimer_ReadTimer(void);              // Deprecated
extern WORD wOneSecTimer_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for OneSecTimer API's.
//--------------------------------------------------

#define OneSecTimer_CONTROL_REG_START_BIT      ( 0x01 )
#define OneSecTimer_INT_REG_ADDR               ( 0x0e1 )
#define OneSecTimer_INT_MASK                   ( 0x02 )


//--------------------------------------------------
// Constants for OneSecTimer user defined values
//--------------------------------------------------

#define OneSecTimer_PERIOD                     ( 0x270f )
#define OneSecTimer_COMPARE_VALUE              ( 0x1388 )


//-------------------------------------------------
// Register Addresses for OneSecTimer
//-------------------------------------------------

#pragma ioport  OneSecTimer_COUNTER_LSB_REG:    0x020      //Count register LSB
BYTE            OneSecTimer_COUNTER_LSB_REG;
#pragma ioport  OneSecTimer_COUNTER_MSB_REG:    0x024      //Count register MSB
BYTE            OneSecTimer_COUNTER_MSB_REG;
#pragma ioport  OneSecTimer_PERIOD_LSB_REG: 0x021          //Period register LSB
BYTE            OneSecTimer_PERIOD_LSB_REG;
#pragma ioport  OneSecTimer_PERIOD_MSB_REG: 0x025          //Period register MSB
BYTE            OneSecTimer_PERIOD_MSB_REG;
#pragma ioport  OneSecTimer_COMPARE_LSB_REG:    0x022      //Compare register LSB
BYTE            OneSecTimer_COMPARE_LSB_REG;
#pragma ioport  OneSecTimer_COMPARE_MSB_REG:    0x026      //Compare register MSB
BYTE            OneSecTimer_COMPARE_MSB_REG;
#pragma ioport  OneSecTimer_CONTROL_LSB_REG:    0x023      //Control register LSB
BYTE            OneSecTimer_CONTROL_LSB_REG;
#pragma ioport  OneSecTimer_CONTROL_MSB_REG:    0x027      //Control register MSB
BYTE            OneSecTimer_CONTROL_MSB_REG;
#pragma ioport  OneSecTimer_FUNC_LSB_REG:   0x120          //Function register LSB
BYTE            OneSecTimer_FUNC_LSB_REG;
#pragma ioport  OneSecTimer_FUNC_MSB_REG:   0x124          //Function register MSB
BYTE            OneSecTimer_FUNC_MSB_REG;
#pragma ioport  OneSecTimer_INPUT_LSB_REG:  0x121          //Input register LSB
BYTE            OneSecTimer_INPUT_LSB_REG;
#pragma ioport  OneSecTimer_INPUT_MSB_REG:  0x125          //Input register MSB
BYTE            OneSecTimer_INPUT_MSB_REG;
#pragma ioport  OneSecTimer_OUTPUT_LSB_REG: 0x122          //Output register LSB
BYTE            OneSecTimer_OUTPUT_LSB_REG;
#pragma ioport  OneSecTimer_OUTPUT_MSB_REG: 0x126          //Output register MSB
BYTE            OneSecTimer_OUTPUT_MSB_REG;
#pragma ioport  OneSecTimer_INT_REG:       0x0e1           //Interrupt Mask Register
BYTE            OneSecTimer_INT_REG;


//-------------------------------------------------
// OneSecTimer Macro 'Functions'
//-------------------------------------------------

#define OneSecTimer_Start_M \
   ( OneSecTimer_CONTROL_LSB_REG |=  OneSecTimer_CONTROL_REG_START_BIT )

#define OneSecTimer_Stop_M  \
   ( OneSecTimer_CONTROL_LSB_REG &= ~OneSecTimer_CONTROL_REG_START_BIT )

#define OneSecTimer_EnableInt_M   \
   M8C_EnableIntMask(  OneSecTimer_INT_REG, OneSecTimer_INT_MASK )

#define OneSecTimer_DisableInt_M  \
   M8C_DisableIntMask( OneSecTimer_INT_REG, OneSecTimer_INT_MASK )

#endif
// end of file OneSecTimer.h
