;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: OneSecTimer.inc
;;   Version: 2.6, Updated on 2011/12/1 at 17:23:24
;;  Generated by PSoC Designer 5.2.2401
;;
;;  DESCRIPTION: Assembler declarations for the Timer16 user module interface
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2011. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for OneSecTimer API's.
;--------------------------------------------------

OneSecTimer_CONTROL_REG_START_BIT:         equ 0x01    ; Control register start bit
OneSecTimer_INT_REG:                       equ 0x0e1
OneSecTimer_INT_MASK:                      equ 0x02


;--------------------------------------------------
; Constants for OneSecTimer user defined values
;--------------------------------------------------

OneSecTimer_PERIOD:                        equ 0x270f
OneSecTimer_COMPARE_VALUE:                 equ 0x1388


;--------------------------------------------------
; Register Address Constants for OneSecTimer
;--------------------------------------------------

OneSecTimer_COUNTER_LSB_REG:           equ 0x20   ; DR0 Counter register
OneSecTimer_COUNTER_MSB_REG:           equ 0x24
OneSecTimer_PERIOD_LSB_REG:            equ 0x21   ; DR1 Period register
OneSecTimer_PERIOD_MSB_REG:            equ 0x25
OneSecTimer_COMPARE_LSB_REG:           equ 0x22   ; DR2 CompareValue register
OneSecTimer_COMPARE_MSB_REG:           equ 0x26
OneSecTimer_CONTROL_LSB_REG:           equ 0x23   ; Control register
OneSecTimer_CONTROL_MSB_REG:           equ 0x27
OneSecTimer_FUNC_LSB_REG:              equ 0x20   ; Function register
OneSecTimer_FUNC_MSB_REG:              equ 0x24
OneSecTimer_INPUT_LSB_REG:             equ 0x21   ; Input register
OneSecTimer_INPUT_MSB_REG:             equ 0x25
OneSecTimer_OUTPUT_LSB_REG:            equ 0x22   ; Output register
OneSecTimer_OUTPUT_MSB_REG:            equ 0x26


;--------------------------------------------------
; OneSecTimer Macro 'Functions'
;--------------------------------------------------

   macro OneSecTimer_Start_M
   or    reg[OneSecTimer_CONTROL_LSB_REG],  OneSecTimer_CONTROL_REG_START_BIT
   endm

   macro OneSecTimer_Stop_M
   and   reg[OneSecTimer_CONTROL_LSB_REG], ~OneSecTimer_CONTROL_REG_START_BIT
   endm

   macro OneSecTimer_EnableInt_M
   M8C_EnableIntMask OneSecTimer_INT_REG, OneSecTimer_INT_MASK
   endm

   macro OneSecTimer_DisableInt_M
   M8C_DisableIntMask OneSecTimer_INT_REG, OneSecTimer_INT_MASK
   endm


; end of file OneSecTimer.inc
